## org.freedesktop.NetworkManager.Settings

org.freedesktop.NetworkManager.Settings — Connection Settings Profile Manager

## Methods

    ListConnections      (OUT ao        connections);
    GetConnectionByUuid  (IN  s         uuid,
                          OUT o         connection);
    AddConnection        (IN  a{sa{sv}} connection,
                          OUT o         path);
    AddConnectionUnsaved (IN  a{sa{sv}} connection,
                          OUT o         path);
    AddConnection2       (IN  a{sa{sv}} settings,
                          IN  u         flags,
                          IN  a{sv}     args,
                          OUT o         path,
                          OUT a{sv}     result);
    LoadConnections      (IN  as        filenames,
                          OUT b         status,
                          OUT as        failures);
    ReloadConnections    (OUT b         status);
    SaveHostname         (IN  s         hostname);

## Signals

    NewConnection     (o connection);
    ConnectionRemoved (o connection);

## Properties

    Connections  readable   ao
    Hostname     readable   s
    CanModify    readable   b

## Description

The Settings interface allows clients to view and administrate the connections stored and used by NetworkManager.

## Method Details

### The ListConnections() method

    ListConnections (OUT ao connections);

List the saved network connections known to NetworkManager.

`OUT ao `connections``: | List of connections.

### The GetConnectionByUuid() method

    GetConnectionByUuid (IN  s uuid,
                         OUT o connection);

Retrieve the object path of a connection, given that connection's UUID.

`IN s `uuid``: | The UUID to find the connection object path for.
`OUT o `connection``: | The connection's object path.

### The AddConnection() method

    AddConnection (IN  a{sa{sv}} connection,
                   OUT o         path);

Add new connection and save it to disk. This operation does not start the network connection unless (1) device is idle and able to connect to the network described by the new connection, and (2) the connection is allowed to be started automatically.

`IN a{sa{sv}} `connection``: | Connection settings and properties.
`OUT o `path``: | Object path of the new connection that was just added.

### The AddConnectionUnsaved() method

    AddConnectionUnsaved (IN  a{sa{sv}} connection,
                          OUT o         path);

Add new connection but do not save it to disk immediately. This operation does not start the network connection unless (1) device is idle and able to connect to the network described by the new connection, and (2) the connection is allowed to be started automatically. Use the 'Save' method on the connection to save these changes to disk.

`IN a{sa{sv}} `connection``: | Connection settings and properties.
`OUT o `path``: | Object path of the new connection that was just added.

### The AddConnection2() method

    AddConnection2 (IN  a{sa{sv}} settings,
                    IN  u         flags,
                    IN  a{sv}     args,
                    OUT o         path,
                    OUT a{sv}     result);

"0x1" (to-disk), "0x2" (in-memory), "0x20" (block-autoconnect). Unknown flags cause the call to fail. `args`: optional arguments dictionary, for extentibility. Currently, no arguments are accepted. Specifying unknown keys causes the call to fail. `path`: Object path of the new connection that was just added. `result`: output argument, currently no additional results are returned.

Add a new connection profile.

Either the flags 0x1 (to-disk) or 0x2 (in-memory) must be specified. The effect is whether to behave like AddConnection or AddConnectionUnsaved. If 0x20 (block-autoconnect) is specified, autoconnect for the new profile is blocked from the beginning. Otherwise, the profile might automatically connect if a suitable device is around.

AddConnection2 is a extensible alternative to AddConnection, and AddConnectionUnsaved. The new variant can do everything that the older variants could, and more.

Since: 1.20

`IN a{sa{sv}} `settings``: | New connection settings, properties, and (optionally) secrets.
`IN u `flags``: | optional flags argument. Currently, the following flags are supported:
`IN a{sv} `args``: |
`OUT o `path``: |
`OUT a{sv} `result``: |

### The LoadConnections() method

    LoadConnections (IN  as filenames,
                     OUT b  status,
                     OUT as failures);

Note that before 1.20, NetworkManager had a bug and this `status` value was wrong. It is better to assume success if the method does not return with a D-Bus error. On top of that, you can look at `failures` to know whether any of the requested files failed. `failures`: Paths of connection files that could not be loaded.

Loads or reloads the indicated connections from disk. You should call this after making changes directly to an on-disk connection file to make sure that NetworkManager sees the changes. As with AddConnection(), this operation does not necessarily start the network connection.

`IN as `filenames``: | Array of paths to on-disk connection profiles in directories monitored by NetworkManager.
`OUT b `status``: | Success or failure of the operation as a whole. True if NetworkManager at least tried to load the indicated connections, even if it did not succeed. False if an error occurred before trying to load the connections (eg, permission denied).
`OUT as `failures``: |

### The ReloadConnections() method

    ReloadConnections (OUT b status);

Tells NetworkManager to reload all connection files from disk, including noticing any added or deleted connection files.

`OUT b `status``: | This always returns `TRUE`.

### The SaveHostname() method

    SaveHostname (IN  s hostname);

Save the hostname to persistent configuration.

`IN s `hostname``: | The hostname to save to persistent configuration. If blank, the persistent hostname is cleared.

## Signal Details

### The "NewConnection" signal

    NewConnection (o connection);

Emitted when a new connection has been added after NetworkManager has started up and initialized. This signal is not emitted for connections read while starting up, because NetworkManager's D-Bus service is only available after all connections have been read, and to prevent spamming listeners with too many signals at one time. To retrieve the initial connection list, call the ListConnections() method once, and then listen for individual Settings.NewConnection and Settings.Connection.Deleted signals for further updates.

`o `connection``: | Object path of the new connection.

### The "ConnectionRemoved" signal

    ConnectionRemoved (o connection);

Emitted when a connection is no longer available. This happens when the connection is deleted or if it is no longer accessible by any of the system's logged-in users. After receipt of this signal, the connection no longer exists and cannot be used. Also see the Settings.Connection.Removed signal.

`o `connection``: | Object path of the removed connection.

## Property Details

### The "Connections" property

    Connections  readable   ao

List of object paths of available network connection profiles.

### The "Hostname" property

    Hostname  readable   s

The machine hostname stored in persistent configuration.

### The "CanModify" property

    CanModify  readable   b

If true, adding and modifying connections is supported.